// Code generated by protoc-gen-go-http. DO NOT EDIT.
// Source: configcenter.proto

package pb

import (
	context "context"
	http1 "net/http"
	strconv "strconv"
	strings "strings"

	transport "github.com/erda-project/erda-infra/pkg/transport"
	http "github.com/erda-project/erda-infra/pkg/transport/http"
	httprule "github.com/erda-project/erda-infra/pkg/transport/http/httprule"
	runtime "github.com/erda-project/erda-infra/pkg/transport/http/runtime"
	urlenc "github.com/erda-project/erda-infra/pkg/urlenc"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the "github.com/erda-project/erda-infra/pkg/transport/http" package it is being compiled against.
const _ = http.SupportPackageIsVersion1

// ConfigCenterServiceHandler is the server API for ConfigCenterService service.
type ConfigCenterServiceHandler interface {
	// GET /api/msp/config/tenants/{tenantID}/groups
	GetGroups(context.Context, *GetGroupRequest) (*GetGroupResponse, error)
	// GET /api/msp/config/tenants/{tenantID}/groups/{groupID}
	GetGroupProperties(context.Context, *GetGroupPropertiesRequest) (*GetGroupPropertiesResponse, error)
	// POST /api/msp/config/tenants/{tenantID}/groups/{groupID}
	SaveGroupProperties(context.Context, *SaveGroupPropertiesRequest) (*SaveGroupPropertiesResponse, error)
}

// RegisterConfigCenterServiceHandler register ConfigCenterServiceHandler to http.Router.
func RegisterConfigCenterServiceHandler(r http.Router, srv ConfigCenterServiceHandler, opts ...http.HandleOption) {
	h := http.DefaultHandleOptions()
	for _, op := range opts {
		op(h)
	}
	encodeFunc := func(fn func(http1.ResponseWriter, *http1.Request) (interface{}, error)) http.HandlerFunc {
		handler := func(w http1.ResponseWriter, r *http1.Request) {
			out, err := fn(w, r)
			if err != nil {
				h.Error(w, r, err)
				return
			}
			if err := h.Encode(w, r, out); err != nil {
				h.Error(w, r, err)
			}
		}
		if h.HTTPInterceptor != nil {
			handler = h.HTTPInterceptor(handler)
		}
		return handler
	}

	add_GetGroups := func(method, path string, fn func(context.Context, *GetGroupRequest) (*GetGroupResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetGroupRequest))
		}
		var GetGroups_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetGroups_info = transport.NewServiceInfo("erda.msp.configcenter.ConfigCenterService", "GetGroups", srv)
			handler = h.Interceptor(handler)
		}
		compiler, _ := httprule.Parse(path)
		temp := compiler.Compile()
		pattern, _ := runtime.NewPattern(httprule.SupportPackageIsVersion1, temp.OpCodes, temp.Pool, temp.Verb)
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetGroups_info)
				}
				r = r.WithContext(ctx)
				var in GetGroupRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				params := r.URL.Query()
				if vals := params["pageNo"]; len(vals) > 0 {
					val, err := strconv.ParseInt(vals[0], 10, 64)
					if err != nil {
						return nil, err
					}
					in.PageNum = val
				}
				path := r.URL.Path
				if len(path) > 0 {
					components := strings.Split(path[1:], "/")
					last := len(components) - 1
					var verb string
					if idx := strings.LastIndex(components[last], ":"); idx >= 0 {
						c := components[last]
						components[last], verb = c[:idx], c[idx+1:]
					}
					vars, err := pattern.Match(components, verb)
					if err != nil {
						return nil, err
					}
					for k, val := range vars {
						switch k {
						case "tenantID":
							in.TenantID = val
						}
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetGroupProperties := func(method, path string, fn func(context.Context, *GetGroupPropertiesRequest) (*GetGroupPropertiesResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*GetGroupPropertiesRequest))
		}
		var GetGroupProperties_info transport.ServiceInfo
		if h.Interceptor != nil {
			GetGroupProperties_info = transport.NewServiceInfo("erda.msp.configcenter.ConfigCenterService", "GetGroupProperties", srv)
			handler = h.Interceptor(handler)
		}
		compiler, _ := httprule.Parse(path)
		temp := compiler.Compile()
		pattern, _ := runtime.NewPattern(httprule.SupportPackageIsVersion1, temp.OpCodes, temp.Pool, temp.Verb)
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, GetGroupProperties_info)
				}
				r = r.WithContext(ctx)
				var in GetGroupPropertiesRequest
				if err := h.Decode(r, &in); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				path := r.URL.Path
				if len(path) > 0 {
					components := strings.Split(path[1:], "/")
					last := len(components) - 1
					var verb string
					if idx := strings.LastIndex(components[last], ":"); idx >= 0 {
						c := components[last]
						components[last], verb = c[:idx], c[idx+1:]
					}
					vars, err := pattern.Match(components, verb)
					if err != nil {
						return nil, err
					}
					for k, val := range vars {
						switch k {
						case "tenantID":
							in.TenantID = val
						case "groupID":
							in.GroupID = val
						}
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_SaveGroupProperties := func(method, path string, fn func(context.Context, *SaveGroupPropertiesRequest) (*SaveGroupPropertiesResponse, error)) {
		handler := func(ctx context.Context, req interface{}) (interface{}, error) {
			return fn(ctx, req.(*SaveGroupPropertiesRequest))
		}
		var SaveGroupProperties_info transport.ServiceInfo
		if h.Interceptor != nil {
			SaveGroupProperties_info = transport.NewServiceInfo("erda.msp.configcenter.ConfigCenterService", "SaveGroupProperties", srv)
			handler = h.Interceptor(handler)
		}
		compiler, _ := httprule.Parse(path)
		temp := compiler.Compile()
		pattern, _ := runtime.NewPattern(httprule.SupportPackageIsVersion1, temp.OpCodes, temp.Pool, temp.Verb)
		r.Add(method, path, encodeFunc(
			func(w http1.ResponseWriter, r *http1.Request) (interface{}, error) {
				ctx := http.WithRequest(r.Context(), r)
				ctx = transport.WithHTTPHeaderForServer(ctx, r.Header)
				if h.Interceptor != nil {
					ctx = context.WithValue(ctx, transport.ServiceInfoContextKey, SaveGroupProperties_info)
				}
				r = r.WithContext(ctx)
				var in SaveGroupPropertiesRequest
				if err := h.Decode(r, &in.Properties); err != nil {
					return nil, err
				}
				var input interface{} = &in
				if u, ok := (input).(urlenc.URLValuesUnmarshaler); ok {
					if err := u.UnmarshalURLValues("", r.URL.Query()); err != nil {
						return nil, err
					}
				}
				path := r.URL.Path
				if len(path) > 0 {
					components := strings.Split(path[1:], "/")
					last := len(components) - 1
					var verb string
					if idx := strings.LastIndex(components[last], ":"); idx >= 0 {
						c := components[last]
						components[last], verb = c[:idx], c[idx+1:]
					}
					vars, err := pattern.Match(components, verb)
					if err != nil {
						return nil, err
					}
					for k, val := range vars {
						switch k {
						case "tenantID":
							in.TenantID = val
						case "groupID":
							in.GroupID = val
						}
					}
				}
				out, err := handler(ctx, &in)
				if err != nil {
					return out, err
				}
				return out, nil
			}),
		)
	}

	add_GetGroups("GET", "/api/msp/config/tenants/{tenantID}/groups", srv.GetGroups)
	add_GetGroupProperties("GET", "/api/msp/config/tenants/{tenantID}/groups/{groupID}", srv.GetGroupProperties)
	add_SaveGroupProperties("POST", "/api/msp/config/tenants/{tenantID}/groups/{groupID}", srv.SaveGroupProperties)
}
